<?
/*
dc.php
Copyright (C) 2005 nainu and ddt

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
require("Sajax.php");

// from php.net
function fetchURL($url) {
   $url_parsed = parse_url($url);
   $host = $url_parsed["host"];
   $port = $url_parsed["port"];
   if ($port==0)
       $port = 80;
   $path = $url_parsed["path"];

   if (empty($path))
   $path="/";

   if ($url_parsed["query"] != "")
       $path .= "?".$url_parsed["query"];
   $out = "GET $path HTTP/1.0\r\nHost: $host\r\n\r\n";
   $fp = fsockopen($host, $port, $errno, $errstr, 30);
   fwrite($fp, $out);
   $body = "";
   while (!feof($fp)) {
     $body .= fgets($fp, 8192);
   }
   fclose($fp);
   return $body;
}

function parse_board($page, $prefix_url) {
  preg_match_all("/(zboard.php\?id\=[^\"]+no=[0-9]+)\"/", $page, $m);
  $urls = array();
  foreach ($m[1] as $url) {
    $urls[] = $prefix_url . $url;
  }
  return $urls;
}

function quote_basename($url) {
  $strings = explode("/", $url);
  $last = count($strings)-1;
  $strings[$last] = rawurlencode($strings[$last]);
  return implode("/", $strings);
}

function parse_page($page) {
  preg_match_all("/img src\=(http[^ ]+jpg)/", $page, $m);
  $urls = array();
  foreach ($m[1] as $url) {
    $urls[] = "<img src=\"" . quote_basename($url) . "\"><br />";
  }
  return $urls;
}

function page_download($url) {
  return fetchURL($url);
}

function get_page($url) {
  $data = "";
  $page_content = page_download($url);
  $images = parse_page($page_content);
  if (count($images) > 0) {
    foreach ($images as $img) {
      $data .= $img . "<br>";
    }
  }
  return $data;
}

function get_board($url) { 
  $content = page_download($url);
  $prefix_url = dirname($url) . "/";
  $pages = parse_board($content, $prefix_url);
  return implode(";", $pages);
}

$sajax_request_type = "GET";
sajax_init();
sajax_export("get_board");
sajax_export("get_page");
sajax_handle_client_request();
?>
<html>
<head>
<title>dcinside</title>
<script>
<?
sajax_show_javascript();
?>

function page_cb(data) {
  document.getElementById("page").innerHTML = document.getElementById("page").innerHTML + data;
}

function get_cb(data) {
  pages = data.split(';');
  size = pages.length;
  for (i=0; i < pages.length ; i++) {
    x_get_page(pages[i], page_cb);
  }
  document.getElementById("msg").innerHTML = "done";
}

function get() {
  document.getElementById("page").innerHTML = "";
  url = document.getElementById("url").value;
  document.getElementById("msg").innerHTML = "loading...";
  x_get_board(url, get_cb);
}
</script>
</head>

<body>
<a href="http://php.net">php</a> <a href="http://www.modernmethod.com/sajax/">sajax</a> ̿ؼ <a href="http://honeydream.net/soojung/">nainu</a> <a href="http://www.nosurprises.org"/>ddt</a> , <a href="http://www.chabrothers.com/~d3m3vilurr/soojung/">d3m3vilurr</a> ׽Ʈ ߽ϴ. ȣ <a href="http://iz4u.net/blog/index.php">darjeeling</a> ־ϴ.
<form name="f" action="#" onsubmit="get();return false;">
<input type="text" id="url" name="url" style="width:70%;" value="http://kr.dcinside5.imagesearch.yahoo.com/zb40/zboard.php?id=moon"/>
<input type="button" value="get page" onclick="get();return false;">
</form>
<div id="msg"></div>
<div id="page"></div>

</body>
</html>
